#include <bits/stdc++.h>

using namespace std;

struct koordinate {int x, y;};

long long resenje(int a, int b, koordinate niz[], int n) {
    long long sol = 0;
    bool z = false, zz = false;
    for(int i = 0; i < n; i++) {
        if(niz[i].x == a) z = true;
        if(niz[i].y == b) zz = true;
        sol += abs(niz[i].x - a) * abs(niz[i].y - b) % 1000000007;
        sol %= 1000000007;
    }
    if(!z || !zz) return 0;
    return sol;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n; koordinate niz[100001];
    cin >> n;
    for(int i = 0; i < n; i++) {
        cin >> niz[i].x >> niz[i].y;
    }
    for(int o = 1; o <= n; o++) {
        long long najsol = 0;
        for(int i = 0; i <= 10; i++) {
            for(int j = 0; j <= 10; j++) {
                najsol = max(resenje(i, j, niz, o), najsol);
            }
        }
        cout << najsol << endl;
    }
}